signature CTX = sig
  type k = string
  type v = Typ.t
  type t
  (* empty () is the empty context *)
  val empty: unit -> t
  (* add x t ctx is a new context, with all the information in ctx, plus the
   * information that x has type t
   *)
  val add: k -> v -> t -> t
  (* get x ctx is SOME t if x has type t in ctx, or NONE otherwise *)
  val get: k -> t -> v option
  (* toString ctx is a string representation of the context *)
  val toString: t -> string
end
