signature EXPR = sig
  datatype t =
    Var of string
  | Int of int
  | Str of string
  | Plus of t * t
  | Concat of t * t
  | Len of t
  | ToStr of t
  (* Let (x, e1, e2) is let x = e1 in e2 *)
  | Let of string * t * t
  (* toString e is a string representation of e *)
  val toString: t -> string
  (* subst e x e' requires e has no free variables and is [e/x] e' *)
  val subst: t -> string -> t -> t
end
