structure Tests:> TESTS = struct
  val Var = Expr.Var
  val Int = Expr.Int
  val Str = Expr.Str
  val Plus = Expr.Plus
  val Concat = Expr.Concat
  val Len = Expr.Len
  val ToStr = Expr.ToStr
  val Let = Expr.Let

  fun someInt (x: int) = SOME (Int x, Typ.Int)
  fun someStr (x: string) = SOME (Str x, Typ.Str)

  val synthtypeAndEval =
    [ (Var "x", NONE)
    , (Int 3, someInt 3)
    , (Str "foo", someStr "foo")
    , (Plus (Int 3, Int 4), someInt 7)
    , (Concat (Str "hello ", Str "world"), someStr "hello world")
    , (Len (Str "bar"), someInt 3)
    , (ToStr (Int 98317), someStr "98317")
    , (Let ("x", Int 5, Var "x"), someInt 5)
    , (Plus (Int 3, Str "foo"), NONE)
    , (Plus (Int 3, Len (Str "ha")), someInt 5)
    , (Let ("x", Int 9, Var "y"), NONE)
    , (Plus (Let ("x", Int 9, Var "x"), Var "x"), NONE)
    , (Concat (ToStr (Int 4), Str " is good"), someStr "4 is good")
    , ( Let ("x", Int 3, Plus (Var "x", Let ("x", Int 4, Var "x")))
      , someInt 7
      )
    ]
end
